/* datameter
 * by Marek Zelem
 * (c)10.7.1999
 */

#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>

int main( void )
{ struct timeval tv,tvn;
  char buf[65536];
  int l;
  unsigned long bytes;
  int tty;
  fd_set fds;
  int inflag;
  	if( (tty=open("/dev/tty",O_WRONLY))<0 )
	{	
//		fprintf(stderr,"Can't open tty!\n");
		tty=2;
//		return(-1);
	}
	gettimeofday(&tv,NULL);
	bytes=0;
	inflag=fcntl(0,F_GETFL,0);
	fcntl(0,F_SETFL,inflag|O_NONBLOCK|O_NDELAY);
	while( (l=read(0,buf,65536))!=0 )
	{	if( l<0 )
		{	FD_ZERO(&fds); FD_SET(0,&fds);
			select(1,&fds,NULL,NULL,NULL);
			continue;
		}
		if( write(1,buf,l)!=l )	break;
		bytes+=l;
		gettimeofday(&tvn,NULL);
		if( tvn.tv_sec>tv.tv_sec )
		{	if( bytes<3*1024 )
			{  sprintf(buf,"\r\t%7.2f B/s        ",
				(double)bytes/(double)(tvn.tv_sec-tv.tv_sec)
			          );
			}
			else if( bytes<3*1024*1024 )
			{  sprintf(buf,"\r\t%7.2f KB/s        ",
				((double)bytes/(double)(tvn.tv_sec-tv.tv_sec))
				/1024
			          );
			}
			else
			{  sprintf(buf,"\r\t%7.2f MB/s        ",
				((double)bytes/(double)(tvn.tv_sec-tv.tv_sec))
				/(1024*1024)
			          );
			}
			write(tty,buf,strlen(buf));
			bytes=0;
			tv=tvn;
		}
	}
	write(tty,"\n",1);
	close(tty);
	fcntl(0,F_SETFL,inflag);
	return(0);
}

